stages:
  - greetings

.elixir: &elixir |
  function elixir_run() {
    # https://stackoverflow.com/questions/4380478/indirect-parameter-substitution-in-shell-script
    param=${1}
    eval source_code=\"\$$param\"
    echo "$source_code" > ${1}.exs
    elixir ${1}.exs
  }

👋:hello:world:
  stage: greetings
  image: elixir:1.10.4-alpine
  before_script:
    - *elixir
  variables:
    source: |
      add = fn a, b -> a + b end

      IO.puts "Hello 🖐️ from Elixir"
      IO.puts "Hello 😃 from Elixir"
      IO.puts :apple == :apple
      part = :world
      IO.puts "👋 hello #{part} 🌍"

      IO.puts "🤖 #{add.(40,2)}"
    sample: |
      IO.puts "Hello 🖖 from Elixir"

  script: |
    elixir_run source
    elixir_run sample

    

